Index: trunk/src/lib/collision_detection/obb_tree_node.cc
===================================================================
--- trunk/src/lib/collision_detection/obb_tree_node.cc	(revision 7677)
+++ trunk/src/lib/collision_detection/obb_tree_node.cc	(revision 7711)
@@ -11,13 +11,12 @@
 ### File Specific:
    main-programmer: Patrick Boenzli
-   co-programmer: ...
 */
 
-#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION
+#define DEBUG_SPECIAL_MODULE 3/* DEBUG_MODULE_COLLISION_DETECTION*/
 
 #include "obb_tree_node.h"
-#include "list.h"
+#include "obb_tree.h"
 #include "obb.h"
-#include "obb_tree.h"
+
 #include "matrix.h"
 #include "model.h"
@@ -26,7 +25,9 @@
 
 #include "color.h"
-
+#include "glincl.h"
+
+#include <list>
+#include <vector>
 #include "debug.h"
-#include "glincl.h"
 
 
@@ -34,43 +35,43 @@
 using namespace std;
 
-OBBTree*  OBBTreeNode::obbTree = NULL;
-
-float**  OBBTreeNode::coMat = NULL;
-float**  OBBTreeNode::eigvMat = NULL;
-float*   OBBTreeNode::eigvlMat = NULL;
-int*     OBBTreeNode::rotCount = NULL;
+
 GLUquadricObj* OBBTreeNode_sphereObj = NULL;
+
 
 /**
  *  standard constructor
+ * @param tree: reference to the obb tree
+ * @param depth: the depth of the obb tree to generate
  */
-OBBTreeNode::OBBTreeNode ()
+OBBTreeNode::OBBTreeNode (const OBBTree& tree, OBBTreeNode* prev, int depth)
+    : BVTreeNode()
 {
   this->setClassID(CL_OBB_TREE_NODE, "OBBTreeNode");
+
+  this->obbTree = &tree;
+  this->nodePrev = prev;
+  this->depth = depth;
+  this->nextID = 0;
+
   this->nodeLeft = NULL;
   this->nodeRight = NULL;
   this->bvElement = NULL;
 
-  if( OBBTreeNode::coMat == NULL)
-  {
-    OBBTreeNode::coMat = new float*[4];
-    for(int i = 0; i < 4; i++)
-      OBBTreeNode::coMat[i] = new float[4];
-  }
-  if( OBBTreeNode::eigvMat == NULL)
-  {
-    OBBTreeNode::eigvMat = new float*[4];
-    for( int i = 0; i < 4; i++)
-      OBBTreeNode::eigvMat[i] = new float[4];
-  }
-  if( OBBTreeNode::eigvlMat == NULL)
-  {
-    OBBTreeNode::eigvlMat = new float[4];
-  }
-  if( OBBTreeNode::rotCount == NULL)
-    OBBTreeNode::rotCount = new int;
+  this->triangleIndexList1 = NULL;
+  this->triangleIndexList2 = NULL;
+
+  this->modelInf = NULL;
+  this->triangleIndexes = NULL;
 
   if( OBBTreeNode_sphereObj == NULL)
     OBBTreeNode_sphereObj = gluNewQuadric();
+
+  this->owner = NULL;
+
+  /* debug ids */
+  if( this->nodePrev)
+    this->treeIndex = 100 * this->depth + this->nodePrev->getID();
+  else
+    this->treeIndex = 0;
 }
 
@@ -82,16 +83,15 @@
 {
   if( this->nodeLeft)
-  {
     delete this->nodeLeft;
-    this->nodeLeft = NULL;
-  }
   if( this->nodeRight)
-  {
     delete this->nodeRight;
-    this->nodeRight = NULL;
-  }
+
   if( this->bvElement)
     delete this->bvElement;
-  this->bvElement = NULL;
+
+//   if( this->triangleIndexList1 != NULL)
+//     delete [] this->triangleIndexList1;
+//   if( this->triangleIndexList2 != NULL)
+//     delete [] this->triangleIndexList2;
 }
 
@@ -105,126 +105,77 @@
  * on the triangle informations (triangle soup not polygon soup)
  */
-void OBBTreeNode::spawnBVTree(const int depth, const modelInfo& modInfo)
-{
-  int length = 0;
-  sVec3D* verticesList;
-
-  PRINT(3)("\n");
-  this->treeIndex = this->obbTree->getID();
-  PRINTF(3)("OBB Depth: %i, tree index: %i, numVertices: %i\n", depth, treeIndex, length);
+void OBBTreeNode::spawnBVTree(const modelInfo& modelInf, const int* triangleIndexes, int length)
+{
+  PRINTF(3)("\n==============================Creating OBB Tree Node==================\n");
+  PRINT(3)(" OBB Tree Infos: \n");
+  PRINT(3)("\tDepth: %i \n\tTree Index: %i \n\tNumber of Triangles: %i\n", depth, this->treeIndex, length);
   this->depth = depth;
 
-
   this->bvElement = new OBB();
-  this->bvElement->vertices = verticesList;
-  this->bvElement->numOfVertices = length;
-  PRINTF(3)("Created OBBox\n");
-  this->calculateBoxCovariance(this->bvElement, modInfo);
-  PRINTF(3)("Calculated attributes1\n");
-  this->calculateBoxEigenvectors(this->bvElement, modInfo);
-  PRINTF(3)("Calculated attributes2\n");
-  this->calculateBoxAxis(this->bvElement,modInfo);
-  PRINTF(3)("Calculated attributes3\n");
-
-  /* if this is the first node, the vertices data are the original ones of the model itself, so dont delete them in cleanup */
-  if( this->treeIndex == 1)
-    this->bvElement->bOrigVertices = true;
-
+  this->bvElement->modelInf = &modelInf;
+  this->bvElement->triangleIndexes = triangleIndexes;
+  this->bvElement->triangleIndexesLength = length;
+
+  // full debug output
+
+  //indexes debug
+//   for( int i = 0; i < length; ++i)
+//   {
+//     PRINTF(2)("triangle[%i], index: %i\n", i, triangleIndexes[i]);
+//   }
+//   for( int i = 0; i < length; ++i)
+//   {
+//     PRINTF(2)("triangle[%i]\n", i);
+//     for(int j = 0; j < 3; ++j)
+//     {
+//       PRINTF(2)("  vertex[%i]: %f, %f, %f\n", j,
+//       (&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[i]].indexToVertices[j]])[0],
+//       (&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[i]].indexToVertices[j]])[1],
+//       (&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[i]].indexToVertices[j]])[2]);
+//     }
+//   }
+//   PRINT(0)("\n\n\n");
+//   for( int i = 0; i < this->bvElement->modelInf->numVertices*3; i+=3)
+//     PRINTF(0)(  "vertex[%i]: %f, %f, %f\n", i, this->bvElement->modelInf->pVertices[i],
+//                this->bvElement->modelInf->pVertices[i+1],
+//                this->bvElement->modelInf->pVertices[i+2]);
+
+
+
+  /* create the bounding boxes in three steps */
+  this->calculateBoxCovariance(*this->bvElement, modelInf, triangleIndexes, length);
+  this->calculateBoxEigenvectors(*this->bvElement, modelInf, triangleIndexes, length);
+//   this->calculateBoxAxis(*this->bvElement, modelInf, triangleIndexes, length);
+//   this->calculateBoxAxis(*this->bvElement, modelInf, triangleIndexes, length);
+  this->calculateBoxAxis(*this->bvElement, modelInf, triangleIndexes, length);
+
+  /* do we need to descent further in the obb tree?*/
   if( likely( this->depth > 0))
   {
-    this->forkBox(this->bvElement);
-
-
-//     if(this->tmpLen1 > 2)
-//     {
-//       OBBTreeNode* node1 = new OBBTreeNode();
-//       this->nodeLeft = node1;
-//       this->nodeLeft->spawnBVTree(depth - 1, this->tmpVert1, this->tmpLen1);
-//     }
-//     else
-//     {
-//       PRINTF(3)("Aboarding tree walk: less than 3 vertices left\n");
-//     }
-//
-//     if( this->tmpLen2 > 2)
-//     {
-//       OBBTreeNode* node2 = new OBBTreeNode();
-//       this->nodeRight = node2;
-//       this->nodeRight->spawnBVTree(depth - 1, this->tmpVert2, this->tmpLen2);
-//     }
-//     else
-//     {
-//       PRINTF(3)("Abording tree walk: less than 3 vertices left\n");
-//     }
-
-  }
-}
+    this->forkBox(*this->bvElement);
+
+    if( this->triangleIndexLength1 >= 3)
+    {
+      this->nodeLeft = new OBBTreeNode(*this->obbTree, this, depth - 1);
+      this->nodeLeft->spawnBVTree(modelInf, this->triangleIndexList1, this->triangleIndexLength1);
+    }
+    if( this->triangleIndexLength2 >= 3)
+    {
+      this->nodeRight = new OBBTreeNode(*this->obbTree, this, depth - 1);
+      this->nodeRight->spawnBVTree(modelInf, this->triangleIndexList2, this->triangleIndexLength2);
+    }
+  }
+}
+
 
 
 /**
- *  creates a new BVTree or BVTree partition
- * @param depth: how much more depth-steps to go: if == 1 don't go any deeper!
- * @param verticesList: the list of vertices of the object - each vertices triple is interpreted as a triangle
- *
- * this function creates an Bounding Volume tree from a vertices soup (no triangle data)
+ *  calculate the box covariance matrix
+ * @param box: reference to the box
+ * @param modelInf: the model info structure of the model
+ * @param tirangleIndexes: an array with the indexes of the triangles inside this
+ * @param length: the length of the indexes array
  */
-void OBBTreeNode::spawnBVTree(const int depth, const sVec3D *verticesList, unsigned int length)
-{
-  PRINT(3)("\n");
-  this->treeIndex = this->obbTree->getID();
-  PRINTF(3)("OBB Depth: %i, tree index: %i, numVertices: %i\n", depth, treeIndex, length);
-  this->depth = depth;
-
-
-  this->bvElement = new OBB();
-  this->bvElement->vertices = verticesList;
-  this->bvElement->numOfVertices = length;
-  PRINTF(3)("Created OBBox\n");
-  this->calculateBoxCovariance(this->bvElement, verticesList, length);
-  PRINTF(3)("Calculated attributes1\n");
-  this->calculateBoxEigenvectors(this->bvElement, verticesList, length);
-  PRINTF(3)("Calculated attributes2\n");
-  this->calculateBoxAxis(this->bvElement, verticesList, length);
-  PRINTF(3)("Calculated attributes3\n");
-
-  /* if this is the first node, the vertices data are the original ones of the model itself, so dont delete them in cleanup */
-  if( this->treeIndex == 1)
-    this->bvElement->bOrigVertices = true;
-
-  if( likely( this->depth > 0))
-  {
-    this->forkBox(this->bvElement);
-
-
-    if(this->tmpLen1 > 2)
-    {
-      OBBTreeNode* node1 = new OBBTreeNode();
-      this->nodeLeft = node1;
-      this->nodeLeft->spawnBVTree(depth - 1, this->tmpVert1, this->tmpLen1);
-    }
-    else
-    {
-      PRINTF(3)("Aboarding tree walk: less than 3 vertices left\n");
-    }
-
-    if( this->tmpLen2 > 2)
-    {
-      OBBTreeNode* node2 = new OBBTreeNode();
-      this->nodeRight = node2;
-      this->nodeRight->spawnBVTree(depth - 1, this->tmpVert2, this->tmpLen2);
-    }
-    else
-    {
-      PRINTF(3)("Abording tree walk: less than 3 vertices left\n");
-    }
-  }
-}
-
-
-void OBBTreeNode::calculateBoxCovariance(OBB* box, const modelInfo& modInfo)
-{}
-
-
-void OBBTreeNode::calculateBoxCovariance(OBB* box, const sVec3D* verticesList, unsigned int length)
+void OBBTreeNode::calculateBoxCovariance(OBB& box, const modelInfo& modelInf, const int* triangleIndexes, int length)
 {
   float     facelet[length];                         //!< surface area of the i'th triangle of the convex hull
@@ -235,191 +186,91 @@
   Vector    t1, t2;                                  //!< temporary values
   float     covariance[3][3] = {0,0,0, 0,0,0, 0,0,0};//!< the covariance matrix
-  int       mode = 0;                                //!< mode = 0: vertex soup, no connections, mode = 1: 3 following verteces build a triangle
-
-  this->numOfVertices = length;
-  this->vertices = verticesList;
-
-
-  if( likely(mode == 0))
-  {
-    /* fist compute all the convex hull face/facelets and centroids */
-    for( int i = 0; i+3 < length ; i+=3)          /* FIX-ME-QUICK: hops of 3, array indiscontinuity*/
-    {
-      p = verticesList[i];
-      q = verticesList[i + 1];
-      r = verticesList[i + 2];
-
-      t1 = p - q; t2 = p - r;
-
-      /* finding the facelet surface via cross-product */
-      facelet[i] = 0.5f * fabs( t1.cross(t2).len() );
-      /* update the entire convex hull surface */
-      face += facelet[i];
-
-      /* calculate the cetroid of the hull triangles */
-      centroid[i] = (p + q + r) * 1/3;
-      /* now calculate the centroid of the entire convex hull, weighted average of triangle centroids */
-      center += centroid[i] * facelet[i];
-    }
-    /* take the average of the centroid sum */
-    center /= face;
-    PRINTF(3)("-- Calculated Center\n");
-
-
-    /* now calculate the covariance matrix - if not written in three for-loops, it would compute faster: minor */
-    for( int j = 0; j < 3; ++j)
-    {
-      for( int k = 0; k < 3; ++k)
+  const float*   tmpVec = NULL;                           //!< a temp saving place for sVec3Ds
+
+  /* fist compute all the convex hull face/facelets and centroids */
+  for( int i = 0; i < length ; ++i)
+  {
+    p = &modelInf.pVertices[modelInf.pTriangles[triangleIndexes[i]].indexToVertices[0]];
+    q = &modelInf.pVertices[modelInf.pTriangles[triangleIndexes[i]].indexToVertices[1]];
+    r = &modelInf.pVertices[modelInf.pTriangles[triangleIndexes[i]].indexToVertices[2]];
+
+    /* finding the facelet surface via cross-product */
+    t1 = p - q;
+    t2 = p - r;
+    facelet[i] = 0.5f * /*fabs*/( t1.cross(t2).len() );
+    /* update the entire convex hull surface */
+    face += facelet[i];
+
+    /* calculate the cetroid of the hull triangles */
+    centroid[i] = (p + q + r) / 3.0f;
+    /* now calculate the centroid of the entire convex hull, weighted average of triangle centroids */
+    center += centroid[i] * facelet[i];
+    /* the arithmetical center */
+  }
+  /* take the average of the centroid sum */
+  center /= face;
+
+
+  /* now calculate the covariance matrix - if not written in three for-loops,
+     it would compute faster: minor */
+  for( int j = 0; j < 3; ++j)
+  {
+    for( int k = 0; k < 3; ++k)
+    {
+      for( int i = 0; i < length; ++i)
       {
-        for( int i = 0; i + 3 < length; i+=3)
-        {
-          p = verticesList[i];
-          q = verticesList[i + 1];
-          r = verticesList[i + 2];
-
-          covariance[j][k] = facelet[i] / (12.0f * face) * (9.0f * centroid[i][j] * centroid[i][k] + p[j] * p[k] +
-              q[j] * q[k] + r[j] * r[k]) - center[j] * center[k];
-        }
+        p = (&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[i]].indexToVertices[0]]);
+        q = (&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[i]].indexToVertices[1]]);
+        r = (&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[i]].indexToVertices[2]]);
+
+        covariance[j][k] = facelet[i] * (9.0f * centroid[i][j] * centroid[i][k] + p[j] * p[k] +
+                           q[j] * q[k] + r[j] * r[k]);
       }
-    }
-    PRINTF(3)("-- Calculated Covariance\n");
-  }
-  else if( mode == 1)
-  {
-    for( int i = 0; i + 3 < length; i+=3)          /* FIX-ME-QUICK: hops of 3, array indiscontinuity*/
-    {
-      p = verticesList[i];
-      q = verticesList[i + 1];
-      r = verticesList[i + 2];
-
-      centroid[i] = (p + q + r) / 3.0f;
-      center += centroid[i];
-    }
-    center /= length;
-
-    for( int j = 0; j < 3; ++j)
-    {
-      for( int k = 0; k < 3; ++k)
-      {
-        for( int i = 0; i + 3 < length; i+=3)
-        {
-          p = verticesList[i];
-          q = verticesList[i +1];
-          r = verticesList[i + 2];
-
-          covariance[j][k] = p[j] * p[k] + q[j] * q[k] + r[j] + r[k];
-        }
-        covariance[j][k] /= (3.0f * length);
-      }
-    }
-    PRINTF(3)("-- Calculated Covariance\n");
-  }
-  else if( mode == 2)
-  {
-    /* fist compute all the convex hull face/facelets and centroids */
-    for(int i = 0; i + 3 < length; i+=3)          /* FIX-ME-QUICK: hops of 3, array indiscontinuity*/
-    {
-      p = verticesList[i];
-      q = verticesList[i + 1];
-      r = verticesList[i + 2];
-
-      t1 = p - q; t2 = p - r;
-
-      /* finding the facelet surface via cross-product */
-      facelet[i] = 0.5f * fabs( t1.cross(t2).len() );
-      /* update the entire convex hull surface */
-      face += facelet[i];
-
-      /* calculate the cetroid of the hull triangles */
-      centroid[i] = (p + q + r) * 1/3;
-      /* now calculate the centroid of the entire convex hull, weighted average of triangle centroids */
-      center += centroid[i] * facelet[i];
-    }
-    /* take the average of the centroid sum */
-    center /= face;
-    PRINTF(3)("-- Calculated Center\n");
-
-    for( int j = 0; j < 3; ++j)
-    {
-      for( int k = 0; k < 3; ++k)
-      {
-        for( int i = 0; i + 3 < length; i+=3)
-        {
-          p = verticesList[i];
-          q = verticesList[i +1];
-          r = verticesList[i + 2];
-
-          covariance[j][k] = p[j] * p[k] + q[j] * q[k] + r[j] + r[k];
-        }
-        covariance[j][k] /= (3.0f * length);
-      }
-    }
-    PRINTF(3)("-- Calculated Covariance\n");
-  }
-  else
-  {
-    for( int i = 0; i < length; ++i)          /* FIX-ME-QUICK: hops of 3, array indiscontinuity*/
-    {
-      center += verticesList[i];
-    }
-    center /= length;
-
-    for( int j = 0; j < 3; ++j)
-    {
-      for( int k = 0; k < 3; ++k)
-      {
-        for( int i = 0; i + 3 < length; i+=3)
-        {
-          p = verticesList[i];
-          q = verticesList[i +1];
-          r = verticesList[i + 2];
-
-          covariance[j][k] = p[j] * p[k] + q[j] * q[k] + r[j] + r[k];
-        }
-        covariance[j][k] /= (3.0f * length);
-      }
-    }
-    PRINTF(3)("-- Calculated Covariance\n");
-  }
-
-  PRINTF(3)("\nVertex Data:\n");
-  for(int i = 0; i < length; i++)
-  {
-    PRINTF(3)("vertex %i: %f, %f, %f\n", i, box->vertices[i][0], box->vertices[i][1], box->vertices[i][2]);
-  }
-
-
-  PRINTF(3)("\nCovariance Matrix:\n");
+      covariance[j][k] = covariance[j][k] / (12.0f * face) - center[j] * center[k];
+    }
+  }
+  for( int i = 0; i < 3; ++i)
+  {
+    box.covarianceMatrix[i][0] = covariance[i][0];
+    box.covarianceMatrix[i][1] = covariance[i][1];
+    box.covarianceMatrix[i][2] = covariance[i][2];
+  }
+  box.center = center;
+
+  /* debug output section*/
+  PRINTF(3)("\nOBB Covariance Matrix:\n");
   for(int j = 0; j < 3; ++j)
   {
-    PRINT(3)(" |");
+    PRINT(3)("\t\t");
     for(int k = 0; k < 3; ++k)
     {
-      PRINT(3)(" \b%f ", covariance[j][k]);
-    }
-    PRINT(3)(" |\n");
-  }
-
-  PRINTF(3)("center: %f, %f, %f\n", center.x, center.y, center.z);
-
-
-  for(int i = 0; i < 3; ++i)
-  {
-    box->covarianceMatrix[i][0] = covariance[i][0];
-    box->covarianceMatrix[i][1] = covariance[i][1];
-    box->covarianceMatrix[i][2] = covariance[i][2];
-  }
-  *box->center = center;
-  PRINTF(3)("-- Written Result to obb\n");
-}
-
-
-void OBBTreeNode::calculateBoxEigenvectors(OBB* box, const modelInfo& modInfo)
-{}
-
-void OBBTreeNode::calculateBoxEigenvectors(OBB* box, const sVec3D* verticesList, unsigned int length)
-{
-
-  /* now getting spanning vectors of the sub-space:
+      PRINT(3)("%11.4f\t", covariance[j][k]);
+    }
+    PRINT(3)("\n");
+  }
+  PRINTF(3)("\nWeighteed OBB Center:\n\t\t%11.4f\t %11.4f\t %11.4f\n", center.x, center.y, center.z);
+//   PRINTF(3)("\nArithmetical OBB Center:\n\t\t%11.4f\t %11.4f\t %11.4f\n", box.arithCenter.x, box.arithCenter.y, box.arithCenter.z);
+
+  /* write back the covariance matrix data to the object oriented bouning box */
+}
+
+
+
+/**
+ *  calculate the eigenvectors for the object oriented box
+ * @param box: reference to the box
+ * @param modelInf: the model info structure of the model
+ * @param tirangleIndexes: an array with the indexes of the triangles inside this
+ * @param length: the length of the indexes array
+ */
+void OBBTreeNode::calculateBoxEigenvectors(OBB& box, const modelInfo& modelInf,
+    const int* triangleIndexes, int length)
+{
+
+  Vector         axis[3];                            //!< the references to the obb axis
+  Matrix         covMat(  box.covarianceMatrix  );   //!< covariance matrix (in the matrix dataform)
+
+  /*
+  now getting spanning vectors of the sub-space:
   the eigenvectors of a symmertric matrix, such as the
   covarience matrix are mutually orthogonal.
@@ -427,142 +278,98 @@
   vectors
   */
-  Vector*              axis = new Vector[3];                //!< the references to the obb axis
-
-  Matrix covMat(  box->covarianceMatrix  );
+
+  /* calculate the axis */
   covMat.getEigenVectors(axis[0], axis[1], axis[2] );
-
-
-  /* new jacobi tests */
-//  JacobI(OBBTreeNode::coMat, OBBTreeNode::eigvlMat, OBBTreeNode::eigvMat, OBBTreeNode::rotCount);
-//  PRINTF(3)("-- Done Jacobi Decomposition\n");
-
-
-//   PRINTF(0)("Jacobi\n");
-//   for(int j = 0; j < 3; ++j)
-//   {
-//     printf(" |");
-//     for(int k = 0; k < 3; ++k)
-//     {
-//       printf(" \t%f ", OBBTreeNode::OBBTreeNode::eigvMat[j][k]);
-//     }
-//     printf(" |\n");
-//   }
-
-/*  axis[0].x = OBBTreeNode::eigvMat[0][0]; axis[0].y = OBBTreeNode::eigvMat[1][0]; axis[0].z = OBBTreeNode::eigvMat[2][0];
-  axis[1].x = OBBTreeNode::eigvMat[0][1]; axis[1].y = OBBTreeNode::eigvMat[1][1]; axis[1].z = OBBTreeNode::eigvMat[2][1];
-  axis[2].x = OBBTreeNode::eigvMat[0][2]; axis[2].y = OBBTreeNode::eigvMat[1][2]; axis[2].z = OBBTreeNode::eigvMat[2][2];
-  axis[0].normalize();
-  axis[1].normalize();
-  axis[2].normalize();*/
-  box->axis = axis;
-
-//   PRINTF(0)("-- Got Axis\n");
-//
-//   PRINTF(0)("eigenvector: %f, %f, %f\n", box->axis[0].x, box->axis[0].y, box->axis[0].z);
-//   PRINTF(0)("eigenvector: %f, %f, %f\n", box->axis[1].x, box->axis[1].y, box->axis[1].z);
-//   PRINTF(0)("eigenvector: %f, %f, %f\n", box->axis[2].x, box->axis[2].y, box->axis[2].z);
-}
-
-
-void OBBTreeNode::calculateBoxAxis(OBB* box, const modelInfo& modInfo)
-{
-  this->calculateBoxAxis(box, (const sVec3D*)modInfo.pVertices, modInfo.numVertices);
-}
-
-
-
-void OBBTreeNode::calculateBoxAxis(OBB* box, const sVec3D* verticesList, unsigned int length)
-{
-
+  box.axis[0] = axis[0];
+  box.axis[1] = axis[1];
+  box.axis[2] = axis[2];
+
+//   box.axis[0] = Vector(1,0,0);
+//   box.axis[1] = Vector(0,1,0);
+//   box.axis[2] = Vector(0,0,1);
+
+  PRINTF(3)("Eigenvectors:\n");
+  PRINT(3)("\t\t%11.2f \t%11.2f \t%11.2f\n", box.axis[0].x, box.axis[0].y, box.axis[0].z);
+  PRINT(3)("\t\t%11.2f \t%11.2f \t%11.2f\n", box.axis[1].x, box.axis[1].y, box.axis[1].z);
+  PRINT(3)("\t\t%11.2f \t%11.2f \t%11.2f\n", box.axis[2].x, box.axis[2].y, box.axis[2].z);
+}
+
+
+
+
+/**
+ *  calculate the eigenvectors for the object oriented box
+ * @param box: reference to the box
+ * @param modelInf: the model info structure of the model
+ * @param tirangleIndexes: an array with the indexes of the triangles inside this
+ * @param length: the length of the indexes array
+ */
+void OBBTreeNode::calculateBoxAxis(OBB& box, const modelInfo& modelInf, const int* triangleIndexes, int length)
+{
+
+  PRINTF(3)("Calculate Box Axis\n");
   /* now get the axis length */
-  Line                ax[3];                                 //!< the axis
-  float*              halfLength = new float[3];             //!< half length of the axis
+  float               halfLength[3];                         //!< half length of the axis
   float               tmpLength;                             //!< tmp save point for the length
-  Plane               p0(box->axis[0], *box->center);       //!< the axis planes
-  Plane               p1(box->axis[1], *box->center);
-  Plane               p2(box->axis[2], *box->center);
-  float               maxLength[3];
-  float               minLength[3];
-
-
-  /* get a bad bounding box */
-  halfLength[0] = -1.0f;
-  for(int j = 0; j < length; ++j)
-    {
-      tmpLength = fabs(p0.distancePoint(vertices[j]));
-      if( tmpLength > halfLength[0])
-        halfLength[0] = tmpLength;
-    }
-
-  halfLength[1] = -1.0f;
-  for(int j = 0; j < length; ++j)
-    {
-      tmpLength = fabs(p1.distancePoint(vertices[j]));
-      if( tmpLength > halfLength[1])
-        halfLength[1] = tmpLength;
-    }
-
-  halfLength[2] = -1.0f;
-  for(int j = 0; j < length; ++j)
-    {
-      tmpLength = fabs(p2.distancePoint(vertices[j]));
-      if( tmpLength > halfLength[2])
-        halfLength[2] = tmpLength;
-    }
-
-
+  Plane               p0(box.axis[0], box.center);           //!< the axis planes
+  Plane               p1(box.axis[1], box.center);           //!< the axis planes
+  Plane               p2(box.axis[2], box.center);           //!< the axis planes
+  float               maxLength[3];                          //!< maximal lenth of the axis
+  float               minLength[3];                          //!< minimal length of the axis
+  const float*        tmpVec;                                //!< variable taking tmp vectors
+  float               centerOffset[3];
 
   /* get the maximal dimensions of the body in all directions */
-    maxLength[0] = p0.distancePoint(vertices[0]);
-    minLength[0] = p0.distancePoint(vertices[0]);
-   for(int j = 0; j < length; ++j)
-   {
-     tmpLength = p0.distancePoint(vertices[j]);
-     if( tmpLength > maxLength[0])
-       maxLength[0] = tmpLength;
-     else if( tmpLength < minLength[0])
-       minLength[0] = tmpLength;
-   }
-
-   maxLength[1] = p1.distancePoint(vertices[0]);
-   minLength[1] = p1.distancePoint(vertices[0]);
-   for(int j = 0; j < length; ++j)
-   {
-     tmpLength = p1.distancePoint(vertices[j]);
-     if( tmpLength > maxLength[1])
-       maxLength[1] = tmpLength;
-     else if( tmpLength < minLength[1])
-       minLength[1] = tmpLength;
-   }
-
-   maxLength[2] = p2.distancePoint(vertices[0]);
-   minLength[2] = p2.distancePoint(vertices[0]);
-   for(int j = 0; j < length; ++j)
-   {
-     tmpLength = p2.distancePoint(vertices[j]);
-     if( tmpLength > maxLength[2])
-       maxLength[2] = tmpLength;
-     else if( tmpLength < minLength[2])
-       minLength[2] = tmpLength;
-   }
-
-
-   /* calculate the real centre of the body by using the axis length */
-   float centerOffset[3];
-   float newHalfLength[3];
-   for(int i = 0; i < 3; ++i)
-     {
-       PRINTF(3)("max: %f, min: %f \n", maxLength[i], minLength[i]);
-       centerOffset[i] = (maxLength[i] + minLength[i]) / 2.0f;       // min length is negatie
-       newHalfLength[i] = (maxLength[i] - minLength[i]) / 2.0f;      // min length is negative
-       *box->center +=  (box->axis[i] * centerOffset[i]);            // update the new center vector
-       halfLength[i] = newHalfLength[i];
-     }
-
-
-
-  box->halfLength = halfLength;
-  PRINTF(3)("-- Written Axis to obb\n");
-  PRINTF(3)("-- Finished Calculating Attributes\n");
+  /* for the initialisation the value just has to be inside of the polygon soup -> first vertices (rand) */
+  for( int k = 0; k  < 3; k++)
+  {
+    tmpVec = (&modelInf.pVertices[modelInf.pTriangles[triangleIndexes[0]].indexToVertices[0]]);
+    Plane* p;
+    if( k == 0)
+      p = &p0;
+    else if( k == 1)
+      p = &p1;
+    else
+      p = &p2;
+    maxLength[k] = p->distancePoint(tmpVec);
+    minLength[k] = p->distancePoint(tmpVec);
+
+    for( int j = 0; j < length; ++j) {
+      for( int i = 0; i < 3; ++i) {
+        tmpVec = &modelInf.pVertices[modelInf.pTriangles[triangleIndexes[j]].indexToVertices[i]];
+        tmpLength = p->distancePoint(tmpVec);
+
+        if( tmpLength > maxLength[k])
+          maxLength[k] = tmpLength;
+        else if( tmpLength < minLength[k])
+          minLength[k] = tmpLength;
+      }
+    }
+  }
+
+
+
+  /* calculate the real centre of the body by using the axis length */
+  for( int i = 0; i < 3; ++i)
+  {
+    if( maxLength[i] > 0.0f && minLength[i] > 0.0f)  // both axis positiv
+      centerOffset[i] = minLength[i] + (maxLength[i] - minLength[i]) / 2.0f;
+    else if( maxLength[i] > 0.0f && maxLength[i] < 0.0f) // positiv and negativ
+      centerOffset[i] = (maxLength[i] + minLength[i]) / 2.0f;
+    else //both negativ
+     centerOffset[i] = minLength[i] + (maxLength[i] - minLength[i]) / 2.0f;
+
+    box.halfLength[i] = (maxLength[i] - minLength[i]) / 2.0f;
+  }
+
+  box.center += (box.axis[0] * centerOffset[0]);
+  box.center += (box.axis[1] * centerOffset[1]);
+  box.center += (box.axis[2] * centerOffset[2]);
+
+
+  PRINTF(3)("\n");
+  PRINT(3)("\tAxis halflength x: %11.2f (max: %11.2f, \tmin: %11.2f), offset: %11.2f\n", box.halfLength[0], maxLength[0], minLength[0], centerOffset[0]);
+  PRINT(3)("\tAxis halflength y: %11.2f (max: %11.2f, \tmin: %11.2f), offset: %11.2f\n", box.halfLength[1], maxLength[1], minLength[1], centerOffset[1] );
+  PRINT(3)("\tAxis halflength z: %11.2f (max: %11.2f, \tmin: %11.2f), offset: %11.2f\n", box.halfLength[2], maxLength[2], minLength[2], centerOffset[2]);
 }
 
@@ -570,45 +377,38 @@
 
 /**
-  \brief this separates an ob-box in the middle
-* @param box: the box to separate
-
-  this will separate the box into to smaller boxes. the separation is done along the middle of the longest axis
+ *  this separates an ob-box in the middle
+ * @param box: the box to separate
+ *
+ * this will separate the box into to smaller boxes. the separation is done along the middle of the longest axis
  */
-void OBBTreeNode::forkBox(OBB* box)
-{
+void OBBTreeNode::forkBox(OBB& box)
+{
+
+  PRINTF(3)("Fork Box\n");
+  PRINTF(4)("Calculating the longest Axis\n");
   /* get the longest axis of the box */
-  float               aLength = -1.0f;                     //!< the length of the longest axis
-  int                 axisIndex = 0;                       //!< this is the nr of the longest axis
-
-  for(int i = 0; i < 3; ++i)
-  {
-    if( aLength < box->halfLength[i])
-    {
-      aLength = box->halfLength[i];
-      axisIndex = i;
-    }
-  }
-
-   PRINTF(3)("longest axis is: nr %i with a half-length of: %f\n", axisIndex, aLength);
-
-
+  float               longestAxis = -1.0f;                 //!< the length of the longest axis
+  int                 longestAxisIndex = 0;                //!< this is the nr of the longest axis
+
+
+  /* now get the longest axis of the three exiting */
+  for( int i = 0; i < 3; ++i)
+  {
+    if( longestAxis < box.halfLength[i])
+    {
+      longestAxis = box.halfLength[i];
+      longestAxisIndex = i;
+    }
+  }
+  PRINTF(3)("\nLongest Axis is: Nr %i with a half-length of:%11.2f\n", longestAxisIndex, longestAxis);
+
+
+  PRINTF(4)("Separating along the longest axis\n");
   /* get the closest vertex near the center */
   float               dist = 999999.0f;                    //!< the smallest distance to each vertex
-  float               tmpDist;                             //!< temporary distance
-  int                 vertexIndex;
-  Plane               middlePlane(box->axis[axisIndex], *box->center); //!< the middle plane
-
-  vertexIndex = 0;
-  for(int i = 0; i < box->numOfVertices; ++i)
-  {
-    tmpDist = fabs(middlePlane.distancePoint(box->vertices[i]));
-    if( tmpDist < dist)
-    {
-      dist = tmpDist;
-      vertexIndex = i;
-    }
-  }
-
-  PRINTF(3)("\nthe clostest vertex is nr: %i, with a dist of: %f\n", vertexIndex ,dist);
+  float               tmpDist;                             //!< variable to save diverse distances temporarily
+  int                 vertexIndex;                         //!< index of the vertex near the center
+  Plane               middlePlane(box.axis[longestAxisIndex], box.center); //!< the middle plane
+  const sVec3D*       tmpVec;                              //!< temp simple 3D vector
 
 
